Imports System.Collections
Imports System.Configuration
Imports System.Data
Imports System.Data.SqlClient

Imports DotNetNuke.Framework.Providers
Imports DotNetNuke.Common.Utilities
Imports DotNetNuke.Data

Namespace EfficionConsulting.Categories
	Public Class CategoryInfo
		
		Private _PortalId as Integer
		Private _CategoryId as Integer
		Private _ParentCategoryId as Integer
		Private _CategoryName as String
		Private _Abbreviation as String
		Private _IconFile as String
		Private _Level As Integer
		Private _PrefixedName as String
		
		Public Sub New()
		End Sub
		
		Public Property CategoryId() As Integer
			Get
				 Return _CategoryId
			End Get
			Set(ByVal Value As Integer)
				 _CategoryId = Value
			End Set
		End Property
		
		Public Property ParentCategoryId() As Integer
			Get
				 Return _ParentCategoryId
			End Get
			Set(ByVal Value As Integer)
				 _ParentCategoryId = Value
			End Set
		End Property
		
		Public Property PortalId() As Integer
			Get
				 Return _PortalId
			End Get
			Set(ByVal Value As Integer)
				 _PortalId = Value
			End Set
		End Property
		
		Public Property Level() As Integer
			Get
				 Return _Level
			End Get
			Set(ByVal Value As Integer)
				 _Level = Value
			End Set
		End Property

		Public Property CategoryName() As String
			Get
				 Return _CategoryName
			End Get
			Set(ByVal Value As String)
				 _CategoryName = Value
			End Set
		End Property

		Public Property Abbreviation() As String
			Get
				 Return _Abbreviation
			End Get
			Set(ByVal Value As String)
				 _Abbreviation = Value
			End Set
		End Property

		Public Property IconFile() As String
			Get
				 Return _IconFile
			End Get
			Set(ByVal Value As String)
				 _IconFile = Value
			End Set
		End Property

		Public Property PrefixedName() As String
			Get
				 Return _PrefixedName
			End Get
			Set(ByVal Value As String)
				 _PrefixedName = Value
			End Set
		End Property
	 End Class

	Public Class CategoryController
		Const _spPrefix as String = "Categories_"
				
		Public Function GetCategories(ByVal PortalId As Integer) As ArrayList
			Return CBO.FillCollection(DataProvider.Instance().ExecuteReader(_spPrefix & "GetCategories", PortalId), GetType(CategoryInfo))
		End Function
		
        Public Function GetParentCategories(ByVal PortalId As Integer) As ArrayList
            Return CBO.FillCollection(DataProvider.Instance().ExecuteReader(_spPrefix & "GetParentCategories", PortalId), GetType(CategoryInfo))
        End Function

        Public Function GetCategoriesByParentID(ByVal PortalId As Integer, ByVal ParentCategoryID As Integer) As ArrayList
            Return CBO.FillCollection(DataProvider.Instance().ExecuteReader(_spPrefix & "Categories_GetCategoriesByParentID", PortalId, ParentCategoryID), GetType(CategoryInfo))
        End Function

        Public Function GetCategory(ByVal CategoryId As Integer) As CategoryInfo
            Return CType(CBO.FillObject(DataProvider.Instance().ExecuteReader(_spPrefix & "GetCategory", CategoryId), GetType(CategoryInfo)), CategoryInfo)
        End Function
		
		Public Sub AddCategory(ByRef objCat as CategoryInfo)
			DataProvider.Instance().ExecuteScalar(_spPrefix &"AddCategory", objCat.PortalId, objCat.CategoryName, objCat.ParentCategoryID, objCat.Abbreviation, objCat.IconFile)
		End Sub
		
		Public Sub UpdateCategory(ByRef objCat as CategoryInfo)
			DataProvider.Instance().ExecuteNonQuery(_spPrefix & "UpdateCategory", objCat.CategoryId, objCat.CategoryName, objCat.ParentCategoryID, objCat.Abbreviation, objCat.IconFile)
		End Sub
		
		Public Sub DeleteCategory(ByVal CategoryId As Integer)
			'TODO: need to decide what to do about child categories and implement
			DataProvider.Instance().ExecuteNonQuery(_spPrefix & "DeleteCategory", CategoryId)
		End Sub
		
		Public Function GetCategoryName(ByVal CategoryId As Integer) As String
			Dim category as CategoryInfo
			category = GetCategory(CategoryID)
			return category.CategoryName
		End Function
		
	End Class
End NameSpace
